2006-08-15  Paul Eggert  <eggert@cs.ucla.edu>

	Port to latest gnulib, and simplify the bootstrapping procedure.
	* intl: Remove this directory and everything in it.
	* depcomp, install-sh, missing, mkinstalldirs, doc/texinfo.tex:
	Remove these files from CVS, as they are now gotten from gnulib.
	* README-CVS: Don't recommend "autoreconf -i", as it doesn't work
	for us.
	* import-gnulib.sh (findutils_files): New var.  Grab this stuff
	from gnulib.
	(findutils_modules): Add fopen-safer; remove stdio-safer.  This
	adjusts to latest gnulib.
	(modules): Remove obsolete reference to intl_modules.
	* .cvsignore: Remove stamp-h; add stamp-h1.
	* doc/.cvsignore: Add regexprops.texi.
	* find/.cvsignore: Add oldfind.
	* lib/.cvsignore: Add .deps, regexprops.
	* m4/.cvsignore: Add Makefile.
	* po/.cvsignore: Add stamp-po.

Index: README-CVS
===================================================================
RCS file: /cvsroot/findutils/findutils/README-CVS,v
retrieving revision 1.9
diff -p -u -r1.9 README-CVS
--- README-CVS	12 Dec 2005 08:26:33 -0000	1.9
+++ README-CVS	15 Aug 2006 21:23:49 -0000
@@ -30,10 +30,6 @@ checked out of CVS, rather than from a r
 
 4. Generate the configure scripts and Makefile.in files.
 
-    autoreconf -i
-
-   ... or use the alternative method ... 
-
     aclocal -I m4 -I gnulib/m4     && \
     autoheader			   && \
     autoconf			   && \
Index: import-gnulib.sh
===================================================================
RCS file: /cvsroot/findutils/findutils/import-gnulib.sh,v
retrieving revision 1.24
diff -p -u -r1.24 import-gnulib.sh
--- import-gnulib.sh	10 Aug 2006 19:36:09 -0000	1.24
+++ import-gnulib.sh	15 Aug 2006 21:23:49 -0000
@@ -1,7 +1,7 @@
 #! /bin/sh
 #
 # import-gnulib.sh -- imports a copy of gnulib into findutils
-# Copyright (C) 2003,2004,2005 Free Software Foundation, Inc.
+# Copyright (C) 2003,2004,2005,2006 Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,37 +20,50 @@
 #
 ##########################################################################
 #
-# This script is intended to populate the "gnulib" directory 
+# This script is intended to populate the "gnulib" directory
 # with a subset of the gnulib code, as provided by "gnulib-tool".
 #
-# To use it, run this script, speficying the location of the 
-# gnulib code as the only argument.   Some sanity-checking is done 
+# To use it, run this script, speficying the location of the
+# gnulib code as the only argument.   Some sanity-checking is done
 # before we commit to modifying things.   The gnulib code is placed
-# in the "gnulib" subdirectory, which is where the buid files expect 
-# it to be. 
-# 
+# in the "gnulib" subdirectory, which is where the buid files expect
+# it to be.
+#
 
-# If CDPATH is set, it will sometimes print the name of the directory 
-# to which you have moved.  Unsetting CDPATH prevents this, as does 
+# If CDPATH is set, it will sometimes print the name of the directory
+# to which you have moved.  Unsetting CDPATH prevents this, as does
 # prefixing it with ".".
 unset CDPATH
 
 destdir="gnulib"
 
 
-# Modules needed for findutils itself.
+# Random extra gnulib files needed for findutils.
+# The source path is relative to gnulib, the destination to .
+findutils_files='
+build-aux/config.guess
+build-aux/config.rpath
+build-aux/config.sub
+build-aux/depcomp
+build-aux/install-sh
+build-aux/mdate-sh
+build-aux/missing
+build-aux/texinfo.tex
+'
+
+# Modules needed for findutils.
 findutils_modules="\
-alloca  argmatch  dirname error fileblocks  fnmatch-gnu fts \
-getline getopt human idcache lstat malloc memcmp memset mktime	\
-modechange pathmax quotearg realloc regex rpmatch savedir stdio-safer \
+alloca argmatch dirname error fileblocks fnmatch-gnu fopen-safer fts \
+getline getopt human idcache lstat malloc memcmp memset mktime \
+modechange pathmax quotearg realloc regex rpmatch savedir \
 stpcpy strdup strftime  strstr strtol strtoul strtoull strtoumax  \
 xalloc xalloc-die xgetcwd  xstrtod xstrtol  xstrtoumax yesno human filemode \
 getline stpcpy canonicalize mountlist closeout gettext stat-macros"
 
-# We need regex to ensure that we can build on platforms like 
-# Solaris which lack those functions. 
+# We need regex to ensure that we can build on platforms like
+# Solaris which lack those functions.
 
-modules="$findutils_modules $intl_modules"
+modules="$findutils_modules"
 export modules
 
 if test $# -lt 1
@@ -83,7 +96,7 @@ else
     exit 1
 fi
 
-    
+
 # exec "$1"/gnulib-tool --create-testdir --dir="$destdir" --lib=libgnulib $modules
 
 if [ -d gnulib ]
@@ -103,6 +116,15 @@ else
 fi
 
 
+for file in $findutils_files; do
+  case $file in
+    */mdate-sh | */texinfo.tex) dest=doc;;
+    *) dest=.;;
+  esac
+  cp -fp "$1"/$file $dest || exit
+done
+
+
 
 cat > gnulib/Makefile.am <<EOF
 # Copyright (C) 2004 Free Software Foundation, Inc.
@@ -135,5 +157,5 @@ EOF
 ## printf "%s" "EXTRA_DIST = "
 ## cd  ./gnulib/m4
 ## ls *.m4 | sed -e 's/$/ \\/' | sed -e '$ s/\\$//'
-## echo 
+## echo
 ## ) > gnulib/m4/Makefile.am
Index: .cvsignore
===================================================================
RCS file: /cvsroot/findutils/findutils/.cvsignore,v
retrieving revision 1.9
diff -p -u -r1.9 .cvsignore
--- .cvsignore	4 Jul 2005 19:45:00 -0000	1.9
+++ .cvsignore	15 Aug 2006 21:23:49 -0000
@@ -9,7 +9,7 @@ config.h.in
 configure
 config.log
 config.status
-stamp-h
+stamp-h1
 config.sub
 config.rpath
 config.guess
Index: doc/.cvsignore
===================================================================
RCS file: /cvsroot/findutils/findutils/doc/.cvsignore,v
retrieving revision 1.6
diff -p -u -r1.6 .cvsignore
--- doc/.cvsignore	14 Jun 2003 15:41:26 -0000	1.6
+++ doc/.cvsignore	15 Aug 2006 21:23:49 -0000
@@ -17,5 +17,6 @@ find.ps
 find.toc
 find.tp
 find.vr
+regexprops.texi
 stamp-vti
 version.texi
Index: find/.cvsignore
===================================================================
RCS file: /cvsroot/findutils/findutils/find/.cvsignore,v
retrieving revision 1.4
diff -p -u -r1.4 .cvsignore
--- find/.cvsignore	14 Jun 2003 15:41:26 -0000	1.4
+++ find/.cvsignore	15 Aug 2006 21:23:49 -0000
@@ -2,3 +2,4 @@
 Makefile
 Makefile.in
 find
+oldfind
Index: lib/.cvsignore
===================================================================
RCS file: /cvsroot/findutils/findutils/lib/.cvsignore,v
retrieving revision 1.5
diff -p -u -r1.5 .cvsignore
--- lib/.cvsignore	14 Jun 2003 15:41:26 -0000	1.5
+++ lib/.cvsignore	15 Aug 2006 21:23:49 -0000
@@ -1,2 +1,4 @@
+.deps
 Makefile
 Makefile.in
+regexprops
Index: m4/.cvsignore
===================================================================
RCS file: /cvsroot/findutils/findutils/m4/.cvsignore,v
retrieving revision 1.5
diff -p -u -r1.5 .cvsignore
--- m4/.cvsignore	24 Oct 2004 22:44:31 -0000	1.5
+++ m4/.cvsignore	15 Aug 2006 21:23:49 -0000
@@ -1 +1,2 @@
+Makefile
 Makefile.in
Index: po/.cvsignore
===================================================================
RCS file: /cvsroot/findutils/findutils/po/.cvsignore,v
retrieving revision 1.2
diff -p -u -r1.2 .cvsignore
--- po/.cvsignore	20 May 2001 20:51:11 -0000	1.2
+++ po/.cvsignore	15 Aug 2006 21:23:49 -0000
@@ -3,3 +3,4 @@ Makefile
 Makefile.in
 POTFILES
 cat-id-tbl.c
+stamp-po