--- find.1	2007-02-22 01:34:53.000000000 +0000
+++ find.1.new	2007-02-22 01:12:50.000000000 +0000
@@ -284,7 +284,7 @@
 Like \-name, but the match is case insensitive.  For example, the
 patterns `fo*' and `F??' match the file names `Foo', `FOO', `foo',
 `fOo', etc.   In these patterns, unlike filename expansion by the
-shell, an initial '.' can be matched by '*'.  That is, 
+shell, an initial `.' can be matched by `*'.  That is, 
 .B find \-name *bar 
 will match the file `.foobar'.   Please note that you should quote
 patterns as a matter of course, otherwise the shell will expand any
@@ -345,23 +345,23 @@
 File's permission bits are exactly \fImode\fR (octal or symbolic).
 Since an exact match is required, if you want to use this form for
 symbolic modes, you may have to specify a rather complex mode string.
-For example '\-perm g=w' will only match files which have mode 0020
+For example `\-perm g=w' will only match files which have mode 0020
 (that is, ones for which group write permission is the only permission
-set).  It is more likely that you will want to use the '/' or '-'
-forms, for example '\-perm \-g=w', which matches any file with group
+set).  It is more likely that you will want to use the `/' or `-'
+forms, for example `\-perm \-g=w', which matches any file with group
 write permission.  See the
 .B EXAMPLES 
 section for some illustrative examples.
 .IP "\-perm \-\fImode\fR"
 All of the permission bits \fImode\fR are set for the file.
 Symbolic modes are accepted in this form, and this is usually the way
-in which would want to use them.  You must specify 'u', 'g' or 'o' if
+in which would want to use them.  You must specify `u', `g' or `o' if
 you use a symbolic mode.   See the 
 .B EXAMPLES 
 section for some illustrative examples.
 .IP "\-perm /\fImode\fR"
 Any of the permission bits \fImode\fR are set for the file.  Symbolic
-modes are accepted in this form.  You must specify 'u', 'g' or 'o' if
+modes are accepted in this form.  You must specify `u', `g' or `o' if
 you use a symbolic mode.  See the
 .B EXAMPLES 
 section for some illustrative examples.  If no permission bits in 
@@ -375,8 +375,8 @@
 Deprecated, old way of searching for files with any of the permission
 bits in \fImode\fR set.  You should use
 .B \-perm \fI/mode\fR
-instead. Trying to use the '+' syntax with symbolic modes will yield
-surprising results.  For example, '+u+x' is a valid symbolic mode
+instead. Trying to use the `+' syntax with symbolic modes will yield
+surprising results.  For example, `+u+x' is a valid symbolic mode
 (equivalent to +u,+x, i.e. 0111) and will therefore not be evaluated
 as
 .B \-perm +\fImode\fR
@@ -389,8 +389,8 @@
 This form of the 
 .B \-perm
 test is deprecated because the POSIX specification requires the
-interpretation of a leading '+' as being part of a symbolic mode, and
-so we switched to using '/' instead.
+interpretation of a leading `+' as being part of a symbolic mode, and
+so we switched to using `/' instead.
 
 .IP "\-regex \fIpattern\fR"
 File name matches regular expression \fIpattern\fR.  This is a match
@@ -464,17 +464,17 @@
 not treat `/' or `.' specially; so, for example,
 .br
 .in +1i
-find . \-wholename './sr*sc'
+find . \-wholename \(aq./sr*sc\(aq
 .br
 .in -1i
-will print an entry for a directory called './src/misc' (if one
+will print an entry for a directory called `./src/misc' (if one
 exists).  To ignore a whole directory tree, use \-prune rather than
 checking every file in the tree.  For example, to skip the
 directory `src/emacs' and all files and directories under it, and
 print the names of the other files found, do something like this:
 .br
 .in +1i
-find . \-wholename './src/emacs' \-prune \-o \-print
+find . \-wholename \(aq./src/emacs\(aq \-prune \-o \-print
 .br
 .in -1i
 .IP "\-xtype \fIc\fR"
@@ -488,7 +488,7 @@
 .IP "\-delete\fR"
 Delete files; true if removal succeeded.  If the removal failed, an
 error message is issued.  Use of this action automatically turns on
-the '\-depth' option.
+the `\-depth' option.
 
 .IP "\-exec \fIcommand\fR ;"
 Execute \fIcommand\fR; true if 0 status is returned.  All following
@@ -516,7 +516,7 @@
 command will be much less than the number of matched files.  The
 command line is built in much the same way that
 .B xargs
-builds its command lines.  Only one instance of '{}' is allowed within
+builds its command lines.  Only one instance of `{}' is allowed within
 the command.  The command is executed in the starting directory.
 
 .IP "\-execdir \fIcommand\fR ;"
@@ -527,7 +527,7 @@
 .BR find .
 This a much more secure method for invoking commands, as it avoids
 race conditions during resolution of the paths to the matched files.
-As with the \-exec option, the '+' form of \-execdir will build a
+As with the \-exec option, the `+' form of \-execdir will build a
 command line to process more than one matched file, but any given
 invocation of
 .I command 
@@ -550,8 +550,8 @@
 .IP "\-fprint \fIfile\fR"
 True; print the full file name into file \fIfile\fR.  If \fIfile\fR
 does not exist when \fBfind\fR is run, it is created; if it does
-exist, it is truncated.  The file names ``/dev/stdout'' and
-``/dev/stderr'' are handled specially; they refer to the standard
+exist, it is truncated.  The file names `/dev/stdout' and
+`/dev/stderr' are handled specially; they refer to the standard
 output and standard error output, respectively.
 The output file is always created, even if the predicate is never matched.
 See the
@@ -668,7 +668,7 @@
 .IP T
 time, 24-hour (hh:mm:ss)
 .IP +
-Date and time, separated by '+', for example `2004\-04\-28+22:22:05'.
+Date and time, separated by `+', for example `2004\-04\-28+22:22:05'.
 The time is given in the current timezone (which may be affected by
 setting the TZ environment variable).  This is a GNU extension.
 .IP X
@@ -750,14 +750,14 @@
 .IP %l
 Object of symbolic link (empty string if file is not a symbolic link).
 .IP %m
-File's permission bits (in octal).  This option uses the 'traditional'
+File's permission bits (in octal).  This option uses the `traditional'
 numbers which most Unix implementations use, but if your particular 
 implementation uses an unusual ordering of octal permissions bits, you
 will see a difference between the actual value of the file's mode and
 the output of %m.   Normally you will want to have a leading
 zero on this number, and to do this, you should use the 
 .B #
-flag (as in, for example, '%#m').
+flag (as in, for example, `%#m').
 .IP %M 
 File's permissions (in symbolic form, as for 
 .BR ls ).  
@@ -848,7 +848,7 @@
 result in the printing of data which is under the control of other
 users.  This includes file names, sizes, modification times and so
 forth.  File names are a potential problem since they can contain any
-character except '\\0' and '/'.  Unusual characters in file names can
+character except `\\0' and `/'.  Unusual characters in file names can
 do unexpected and often undesirable things to your terminal (for
 example, changing the settings of your function keys on some
 terminals).  Unusual characters are handled differently by various
@@ -859,7 +859,7 @@
 .IP "\-ls, \-fls"
 Unusual characters are always escaped.  White space, backslash, and
 double quote characters are printed using C-style escaping (for
-example '\\f', '\\"').  Other unusual characters are printed using an
+example `\\f', `\\"').  Other unusual characters are printed using an
 octal escape.  Other printable characters (for \-ls and \-fls these are
 the characters between octal 041 and 0176) are printed as-is.
 .IP "\-printf, \-fprintf"
@@ -877,7 +877,7 @@
 \-fls.   If you are able to decide what format to use for the output 
 of 
 .B find
-then it is normally better to use '\\0' as a terminator
+then it is normally better to use `\\0' as a terminator
 than to use newline, as file names can contain white space and newline
 characters.
 .IP "\-print, \-fprint"
@@ -934,7 +934,7 @@
 POSIX conformance of the system's 
 .BR fnmatch (3) 
 library function.  As of findutils-4.2.2, shell metacharacters
-('*'. '?' or '[]' for example) will match a leading '.', because 
+(`*'. `?' or `[]' for example) will match a leading `.', because 
 IEEE PASC interpretation 126 requires this.   This is a change from
 previous versions of findutils.
 .IP "\-type"
@@ -1086,19 +1086,19 @@
 
 .P
 .nf
-.B find . \-type f \-exec file '{}' \e\;
+.B find . \-type f \-exec file \(aq{}\(aq \e\;
 
 .fi
 Runs `file' on every file in or below the current directory.  Notice
 that the braces are enclosed in single quote marks to protect them
 from interpretation as shell script punctuation.   The semicolon is
-similarly protected by the use of a backslash, though ';' could have
+similarly protected by the use of a backslash, though `;' could have
 been used in that case also.
 
 .P
 .nf
-.B find /  \t\e( \-perm \-4000 \-fprintf /root/suid.txt '%#m %u %p\en' \e) , \e
-.B       \t\t\e( \-size +100M \-fprintf /root/big.txt  '%\-10s %p\en' \e)
+.B find /  \t\e( \-perm \-4000 \-fprintf /root/suid.txt \(aq%#m %u %p\en\(aq \e) , \e
+.B       \t\t\e( \-size +100M \-fprintf /root/big.txt  \(aq%\-10s %p\en\(aq \e)
 
 .fi
 Traverse the filesystem just once, listing setuid files and
@@ -1199,8 +1199,8 @@
 \fBlstat\fP(2), \fBls\fP(1), \fBprintf\fP(3), \fBstrftime\fP(3),
 \fBctime\fP(3), \fBFinding Files\fP (on-line in Info, or printed).
 .SH "HISTORY"
-As of findutils-4.2.2, shell metacharacters ('*'. '?' or '[]' for
-example) used in filename patterns will match a leading '.', because
+As of findutils-4.2.2, shell metacharacters (`*'. `?' or `[]' for
+example) used in filename patterns will match a leading `.', because
 IEEE POSIX interpretation 126 requires this.
 .SH "NON-BUGS"
 .nf
@@ -1223,7 +1223,7 @@
 That command is of course not going to work.  Instead of doing things
 this way, you should enclose the pattern in quotes:
 .nf
-.B $ find . \-name \'*.c\' \-print
+.B $ find . \-name \(aq*.c\(aq \-print
 .fi
 
 .SH "BUGS"