2004-12-09  Stepan Kasal  <kasal@ucw.cz>

	* doc/find.texi (Directories): Don't use the phrase ``current
	  directory'' in the definition of ``-prune''; the previous
	  wording might give an impression that calling this action on
	  a regular file might have some effect.
	(Full Name Patterns): Better example for ``-regex''.
	(Database Locations): Replaced the list of options by an @xref;
	  this was almost exact copy of the node ``Invoking updatedb''.
	(Invoking updatedb): Minor changes.
	* find/find.1: The same changes for -prune and -regex, plus one
	  fix of quoting style.

Index: doc/find.texi
===================================================================
RCS file: /cvsroot/findutils/findutils/doc/find.texi,v
retrieving revision 1.48
diff -u -r1.48 find.texi
--- doc/find.texi	24 Nov 2004 21:06:37 -0000	1.48
+++ doc/find.texi	9 Dec 2004 10:05:19 -0000
@@ -383,7 +383,7 @@
 True if the entire file name matches regular expression @var{expr}.
 This is a match on the whole path, not a search.  For example, to match
 a file named @file{./fubar3}, you can use the regular expression
-@samp{.*bar.} or @samp{.*b.*3}, but not @samp{b.*r3}.  @xref{Regexps, ,
+@samp{.*bar.} or @samp{.*b.*3}, but not @samp{f.*r3}.  @xref{Regexps, ,
 Syntax of Regular Expressions, emacs, The GNU Emacs Manual}, for a
 description of the syntax of regular expressions.  For @samp{-iregex},
 the match is case-insensitive.
@@ -951,10 +951,10 @@
 @end deffn
 
 @deffn Action -prune
-If @samp{-depth} is not given, true; do not descend into the current
-directory.  If @samp{-depth} is given, false; no effect.  @samp{-prune}
-only affects tests and actions that come after it in the expression, not
-those that come before.
+If @samp{-depth} is not given, true; if the file is a directory, do
+not descend into it.
+
+If @samp{-depth} is given, false; no effect.
 
 For example, to skip the directory @file{src/emacs} and all files and
 directories under it, and print the names of the other files found:
@@ -2172,52 +2172,11 @@
 the root of each filesystem, containing the entries for that filesystem.
 @code{updatedb} is then run for each filesystem on the fileserver where
 that filesystem is on a local disk, to prevent thrashing the network.
-Here are the options to @code{updatedb} to select which directories each
-database contains entries for:
-
-@table @code
-@item --findoptions='@var{OPTION}@dots{}'
-Global options to pass on to @code{find}.
-The environment variable @code{FINDOPTIONS} also sets this value.
-Default is none.
-
-@item --localpaths='@var{path}@dots{}'
-Non-network directories to put in the database.
-Default is @file{/}.
-
-@item --netpaths='@var{path}@dots{}'
-Network (NFS, AFS, RFS, etc.) directories to put in the database.
-The environment variable @code{NETPATHS} also sets this value.
-Default is none.
-
-
-@item --prunepaths='@var{path}@dots{}'
-Directories to not put in the database, which would otherwise be.
-The environment variable @code{PRUNEPATHS} also sets this value.
-Default is @file{/tmp /usr/tmp /var/tmp /afs}.
 
-@item --prunefs='@var{path}@dots{}'
-File systems to not put in the database, which would otherwise be.
-Note that files are pruned when a file system is reached;
-Any file system mounted under an undesired file system will be
-ignored.
-The environment variable @code{PRUNEFS} also sets this value.
-Default is @file{nfs NFS proc}.
+@xref{Invoking updatedb},
+for the description of the options to @code{updatedb}, which specify
+which directories would each database contain entries for.
 
-@item --output=@var{dbfile}
-The database file to build.
-Default is system-dependent, but typically @file{/usr/local/var/locatedb}.
-
-@item --localuser=@var{user}
-The user to search the non-network directories as, using @code{su}.
-Default is to search the non-network directories as the current user.
-You can also use the environment variable @code{LOCALUSER} to set this user.
-
-@item --netuser=@var{user}
-The user to search network directories as, using @code{su}.
-Default is @code{daemon}.
-You can also use the environment variable @code{NETUSER} to set this user.
-@end table
 
 @node Database Formats
 @section Database Formats
@@ -2590,7 +2549,7 @@
 Default is none.
 
 @item --prunepaths='@var{path}@dots{}'
-Directories to not put in the database, which would otherwise be.
+Directories to omit from the database, which would otherwise be included.
 The environment variable @code{PRUNEPATHS} also sets this value.
 Default is @file{/tmp /usr/tmp /var/tmp /afs}.
 
@@ -2612,7 +2571,7 @@
 You can also use the environment variable @code{LOCALUSER} to set this user.
 
 @item --netuser=@var{user}
-The user to search network directories as, using @code{su}(1).
+The user to search network directories as, using @code{su}.
 Default is @code{daemon}.
 You can also use the environment variable @code{NETUSER} to set this user.
 @end table
Index: find/find.1
===================================================================
RCS file: /cvsroot/findutils/findutils/find/find.1,v
retrieving revision 1.36
diff -u -r1.36 find.1
--- find/find.1	3 Dec 2004 17:53:54 -0000	1.36
+++ find/find.1	9 Dec 2004 10:05:19 -0000
@@ -326,13 +326,13 @@
 File name matches regular expression \fIpattern\fR.  This is a match
 on the whole path, not a search.  For example, to match a file named
 `./fubar3', you can use the regular expression `.*bar.' or `.*b.*3',
-but not `b.*r3'.  The regular expressions understood by 
+but not `f.*r3'.  The regular expressions understood by 
 .B find 
 follow the conventions for the 
 .B re_match 
 system library function where this is present (i.e. on systems using
 the GNU C Library).  On other systems, the implementation within
-Gnulib is used; by default, Gnulib provides "basic" regular
+Gnulib is used; by default, Gnulib provides ``basic'' regular
 expressions.
 .IP "\-size \fIn\fR[cwbkMG]"
 File uses \fIn\fP units of space.  The following suffixes 
@@ -674,7 +674,8 @@
 
 .RE
 .IP \-prune
-If \-depth is not given, true; do not descend the current directory.
+If \-depth is not given, true; if the file is a directory, do not descend
+into it.
 .br
 If \-depth is given, false; no effect.
 